#ifndef _XADIO_H
#define _XADIO_H

#define XADIO_FPGATYPE      1 /* major changes 0=old mode using 31 Bit Counter, 1=new mode using 2x32Bit Counter*/
#define XADIO_STRING        "xadio"


/* Samples Record when reading from Samples-Device /proc/xadio/xadio?/Samples */

#define XADIO_CHANNELS  8
#define XADIO_ADC_BITS 16
#define XADIO_DAC_BITS 18
#define XADIO_CONFIG_ROMSIZE 256

/* Record when reading from Samples-Device "/proc/xadio/xadio?/samples" */

typedef struct {
  int adc[XADIO_CHANNELS];
  unsigned digio; 
  int inc0;
  int dac0;
  int dac1;
unsigned timer32; 
  int inc1;
  int fi1;
  int fi2;
} Xadio_record;

/* Strings when reading from Control-Device "/proc/xadio/xadio?/control */
#define XADIO_CONTROL_debug       "debug"
#define XADIO_CONTROL_version     "version"
#define XADIO_CONTROL_hwversion   "hwversion"
#define XADIO_CONTROL_cardnum     "cardnum"  
#define XADIO_CONTROL_fpgaversion "fpgaversion"
#define XADIO_CONTROL_tcelsius    "tcelsius"
#define XADIO_CONTROL_brecords    "brecords"
#define XADIO_CONTROL_bcount      "bcount"
#define XADIO_CONTROL_freq        "freq"
#define XADIO_CONTROL_incmode0    "incmode0"
#define XADIO_CONTROL_incmode1    "incmode1"
#define XADIO_CONTROL_adcbits     "adcbits"
#define XADIO_CONTROL_dacbits     "dacbits"
#define XADIO_CONTROL_channels    "channels"
#define XADIO_CONTROL_frequencies "frequencies"
#define XADIO_CONTROL_configrom   "configrom"
#define XADIO_CONTROL_EEversion    "EEversion"
#define XADIO_CONTROL_EEhwversion  "EEhwversion"
#define XADIO_CONTROL_EEcardyear   "EEcardyear"
#define XADIO_CONTROL_EEcardnumber "EEcardnumber"
#define XADIO_CONTROL_EEjumper0    "EEjumper0"
#define XADIO_CONTROL_EEjumper1    "EEjumper1"
#define XADIO_CONTROL_EEjumper2    "EEjumper2"
#define XADIO_CONTROL_EEjumper3    "EEjumper3"
#define XADIO_CONTROL_EEjumper4    "EEjumper4"
#define XADIO_CONTROL_EEjumper5    "EEjumper5"
#define XADIO_CONTROL_EEjumper6    "EEjumper6"
#define XADIO_CONTROL_EEjumper7    "EEjumper7"
#define XADIO_CONTROL_EEcalib0     "EEcalib0"
#define XADIO_CONTROL_EEcalib1     "EEcalib1"
#define XADIO_CONTROL_EEcalib2     "EEcalib2"
#define XADIO_CONTROL_EEcalib3     "EEcalib3"
#define XADIO_CONTROL_EEcalib4     "EEcalib4"
#define XADIO_CONTROL_EEcalib5     "EEcalib5"
#define XADIO_CONTROL_EEcalib6     "EEcalib6"
#define XADIO_CONTROL_EEcalib7     "EEcalib7"
#define XADIO_CONTROL_div0     		"div0"
#define XADIO_CONTROL_div1     		"div1"

/* Strings when writing to Control-Device "/proc/xadio/xadio?/control */

#define XADIO_CONTROL_setfreq      "setfreq"	 /* 3000..190000 */
#define XADIO_CONTROL_setincmode0  "setincmode0" /* 0..3 */
#define XADIO_CONTROL_setincmode1  "setincmode1" /* 0..3 */
#define XADIO_CONTROL_setda0       "setda0"      /* value in uV */
#define XADIO_CONTROL_setda1       "setda1"      /* value in uV */
#define XADIO_CONTROL_setdax0      "setdax0"     /* value in digits (will disappear in the near future! )*/
#define XADIO_CONTROL_setdax1      "setdax1"     /* value in digits */
#define XADIO_CONTROL_setdigio     "setdigio"    /* value mask */
#define XADIO_CONTROL_reset        "reset"
#define XADIO_CONTROL_resetcounter "resetcounter"
#define XADIO_CONTROL_resetadu     "resetadu"
#define XADIO_CONTROL_calibrate    "calibrate"
#define XADIO_CONTROL_dmastop      "dmastop"
#define XADIO_CONTROL_dmastart     "dmastart"
#define XADIO_CONTROL_setconfigrom "setconfigrom"
#define XADIO_CONTROL_settestmode  "settestmode"    /* 0: measurement  1: 0V  3: Umax */
#define XADIO_CONTROL_setdebugmode "setdebugmode"    /* 0: measurement  1: 0V  3: Umax */
#define XADIO_CONTROL_setdiv0      "setdiv0" /* divider-inccounter to determine the current rpm 0.. */
#define XADIO_CONTROL_setdiv1      "setdiv1" /* divider-inccounter to determine the current rpm 0.. */
#define XADIO_CONTROL_setrpmencoder "setrpmencoder" /* 0/1 */

/* Strings when reading from Values-Device "/proc/xadio/xadio?/values" */

#define XADIO_VALUES_timer         "timer"
#define XADIO_VALUES_timer32       "timer32"
#define XADIO_VALUES_inc0          "inc0"
#define XADIO_VALUES_inc1          "inc1"
#define XADIO_VALUES_adc0          "adc0"
#define XADIO_VALUES_adc1          "adc1"
#define XADIO_VALUES_adc2          "adc2"
#define XADIO_VALUES_adc3          "adc3"
#define XADIO_VALUES_adc4          "adc4"
#define XADIO_VALUES_adc5          "adc5"
#define XADIO_VALUES_adc6          "adc6"
#define XADIO_VALUES_adc7          "adc7"
#define XADIO_VALUES_dac0          "dac0"
#define XADIO_VALUES_dac1          "dac1"
#define XADIO_VALUES_digio         "digio"
#define XADIO_VALUES_rpm0          "rpm0"	 	
#define XADIO_VALUES_rpm1          "rpm1"	 	
/* Bits im Digitalio-Register */

#define XADIO_COUNTER0_RESET      0x100000
#define XADIO_COUNTER0_A1         0x200000
#define XADIO_COUNTER0_A2         0x400000
#define XADIO_FASTIN_3            0x800000

#define XADIO_COUNTER1_RESET      0x010000
#define XADIO_COUNTER1_A1         0x020000
#define XADIO_COUNTER1_A2         0x040000
#define XADIO_FASTIN_7            0x080000

#endif
